indexpos(head,f1,n)
char head[][80],f1[8];
int n;
{
  int i,j;
  for(i=0;i<n;i++){
    for(j=0;j<8;j++) if(head[i][j]!=f1[j])goto l10;
    return i;
l10:
    continue;
  }
  return i;
}

swap4(char *a, int n)       /*     int  a[n] or float a[n]    */
{
  register char *p;
  register int i;
  register char c,d;
  p = a;		
  for(i=0;i<n;i+=4){
    c = *p;
    *p++ = *(p+3);
    d = *p;
    *p++ = *(p+1);
    *p++ = d;
    *p++ = c;
  }
}

white_black(map,n1,n2,peak,sigma)
short map[];
int n1,n2;
float *peak,*sigma;
{
  int *ihist;
  ihist=(int*)malloc(32767*4);
  white_black_1(map,n1,n2,peak,sigma,ihist);
  free(ihist);
}

white_black_1(map,n1,n2,xpeak,sigma,ihist)
short map[]; int n1,n2;
float *xpeak, *sigma;
int   ihist[];
{
  int i,ii;
  int imax=0;
  for(i=0;i<32767;i++)ihist[i]=0;
  for(i=0;i<n1*n2;i++){
    ii=map[i];
    ii+=101;
    if(ii<0 || ii >= 32767)continue;
    ihist[ii]++;
    if(ii>imax)imax=ii;
  }
  histat(ihist,xpeak,sigma,imax);
  *xpeak-=100.0;
}

histat(ihist,xpeak,fsigma,n)
int  ihist[];
float *xpeak,*fsigma;
int   n;
{
  int ihtot=0, ihsum=0, iwid=0, maxh=0, mode=0;
  int i,ii,j,jj,k,m,nn, isigm, nfilt, noff, ixpeak, ilow, ihih,ilim,icount;
  float xpar[101],buf[201];
  float xmean=0., xmed=0, sigmsq=0., xcount=0;
  float rttpi, conv, xx, temp, xp,fs,gs,cogd,cogn,cog,xnumb,sd;

  rttpi=2.506628275;
  for(i=1;i<=n;i++){
    nn=n+1-i;
    if(ihist[nn]!=0)break;
  }
  for(i=1;i<=nn;i++)ihtot+=ihist[i];
  for(i=1;i<=nn;i++){
    ihsum+=ihist[i];
    if(ihsum < 0.1*ihtot || ihsum > 0.9*ihtot)continue;
    if(ihist[i] <= maxh)continue;
    maxh=ihist[i];
    mode=i;
  }
  for(i=1;i<=nn;i++){
    temp=ihist[i];
    xcount+=temp;
    xmean+=temp*i;
    sigmsq+=temp*i*i;
  }
  for(i=1;i<=nn;i++){
    xmed+=ihist[i];
   if(xmed > 0.5*xcount){ xmed=i; break; }
  }
  xmean/=xcount;
  gs=xcount/(maxh*rttpi);
  if(gs > 0.1*nn)gs=0.1*nn;
  isigm=gs+0.5;
  if(isigm<3)isigm=3;
  if(isigm>50)isigm=50;
  nfilt=isigm*4+1;
  noff=(nfilt+1)/2;
  conv=0.5/(float)(isigm*isigm);
  for(i=1;i<=noff;i++){
    xx=i-noff;
    buf[i]=exp(-conv*xx*xx);
    buf[nfilt+1-i]=buf[i];
  }
  xp=mode;
  for(k=1;k<=2;k++){
    ixpeak=xp+0.5;
    if(ixpeak > nn)ixpeak=nn;
    if(ixpeak <1 )ixpeak=1;
    ilow=ixpeak-isigm;
    if(ilow <1 )ilow=1;
    ihih=ixpeak+isigm;
    if(ihih >nn)ihih=nn;
    m=ihih-ilow+1;
    ii=1;  cogd=cogn=0.;
    for(i=ilow;i<=ihih;i++){
      cogd+=ihist[i];
      cogn+=ihist[i]*i;
      temp=xnumb=0.;
      for(j=1;j<=nfilt;j++){
	jj=j-noff;
	if(i+jj < 1 || i+jj > nn)continue;
	temp+=ihist[i+jj]*buf[j];
	xnumb+=buf[j];
      }
      temp = (xnumb > 0.) ? temp/=xnumb : 0. ;
      if(temp < 1.)temp=1.;
      xpar[ii++]=log((double)temp);
    }
    parbol(xpar,m,&xp,&sd);
    xx=sd*sd-isigm*isigm;
    if(xx < 0.)xx=0.;
    fs=sqrt((double)xx);
    xp+=ilow-1;
    cog=(cogd > .5) ? cogn/cogd : xp;
    xx=xp-mode; if(xx <0.)xx=-xx;
    if(xx > gs)xp=cog;
  }
  mode--;
  xp=xp-1.0;
  xmean=xmean-1.0;
  xmed=xmed-1.0;
  if(xp > nn-gs)xp=xmed;
  if(xp < gs)xp=xmed;
  ixpeak=xp+1.5;
  icount=ihist[ixpeak];
  ilim=0.68*xcount+0.5;
  for(i=1;i<=nn;i++){
    ii=ixpeak+i;
    if(ii <= nn){
      iwid++;
      icount+=ihist[ii];
      if(icount > ilim)break;
    }
    ii=ixpeak-i;
    if(ii >= 1){
      iwid++;
      icount+=ihist[ii];
      if(icount > ilim)break;
    }
  }
  gs=0.5*iwid;
  if(gs<fs)fs=gs;
  if(fs<1.)fs=1.;
  *xpeak=xp;
  *fsigma=fs;
}

parbol(a,n,xpeak,sd)
float a[],*xpeak,*sd; int n;
{
  double aa,fi,fi2, cmatx[6][6],bvect[6];  
  double suma=0.,sumay=0.,sumayy=0.,sumy1=0.,sumy2=0.,sumy3=0.,sumy4=0.;
  int i,j;

  for(i=0;i<6;i++){ bvect[i]=0.; for(j=0;j<6;j++)cmatx[i][j]=0.; }
  for(i=1;i<=n;i++){          //data from fortran. start with 1
    aa=a[i]; fi=i; fi2=i*i;
    suma+=aa;  sumay+=aa*fi; sumayy+=aa*fi2;
    sumy1+=fi; sumy2+=fi2;   sumy3+=fi*fi2;   sumy4+=fi2*fi2;
  }
  cmatx[0][0]=n;     cmatx[0][1]=sumy1; cmatx[0][2]=sumy2;
  cmatx[1][0]=sumy1; cmatx[1][1]=sumy2; cmatx[1][2]=sumy3;
  cmatx[2][0]=sumy2; cmatx[2][1]=sumy3; cmatx[2][2]=sumy4;
  bvect[0]=suma;     bvect[1]=sumay;    bvect[2]=sumayy;
  matrix(cmatx,bvect,3);
  if(bvect[2] == 0) *xpeak= *sd=0.;
  else {
    aa=bvect[2]*2.;
    *xpeak=-bvect[1]/aa;
    if(aa < 0.)aa=-aa;
    *sd=sqrt((double)1.0/aa);
  }
}

plate(ad,xy,w,nm,c,nc)
double ad[][2],xy[][2],c[6][2]; char w[]; int nm,nc;
{
  int i,j,k,ixy;
  double a[6][6],b[6],wk[6],z;
  for(ixy=0;ixy<2;ixy++){
    for(j=0;j<nc;j++){ b[j]=0.; for(i=0;i<nc;i++)a[j][i]=0.; }
    for(k=0;k<nm;k++){ if(w[k]!=1)continue;
      wk[0]=xy[k][0]; wk[1]=xy[k][1]; wk[2]=1.; z=ad[k][0]; if(ixy)z=ad[k][1];
      for(j=0;j<nc;j++){ b[j]+=wk[j]*z; for(i=0;i<nc;i++)a[i][j]+=wk[i]*wk[j]; }
    }
    matrix(a,b,nc); for(i=0;i<nc;i++)c[i][ixy]=b[i];
  }
}

matrix(a,b,m)
double a[][6],*b; int m;
{
  int i,j,k,l; double s,t;
  for(i=0;i<m-1;i++){ s=0.;
    for(k=i;k<m;k++){ t=a[k][i]; if(t<0.)t=-t; if(t>s){ s=t; l=k; } }
    if(s==0.){ for(k=0;i<m;k++)b[k]=0; printf("Matrix err\n"); return; }
    if(i!=l){
      for(j=0;j<m;j++){ t=a[i][j]; a[i][j]=a[l][j]; a[l][j]=t;}
      t=b[i]; b[i]=b[l]; b[l]=t;
    } s=a[i][i];
    for(j=i+1;j<m;j++){
      t=a[j][i]/s; b[j]-=t*b[i]; for(k=i;k<m;k++)a[j][k]-=t*a[i][k];
    }
  }
  for(i=0;i<m;i++){ l=m-1-i; if(a[l][l]==0.){ b[l]=0.; continue; }
    t=b[l]; if(l!=m-1)for(j=1;j<=i;j++){ k=m-j; t-=a[l][k]*b[k]; }
    b[l]=t/a[l][l];
  }
}

